searchNodes=[{"doc":"Spawn Elixir SDK is the support library for the Spawn Actors System. Spawn is a Stateful Serverless Platform for provide the multi-language Actor Model. For a broader understanding of Spawn please consult its official repository . The advantage of the Elixir SDK over other SDKs is in Elixir's native ability to connect directly to an Erlang network. For this reason the Elixir SDK allows any valid Elixir application to be part of a Spawn network without the need for a sidecar attached. Installation Available in Hex , the package can be installed by adding spawn_sdk and spawn_statestores_* to your list of dependencies in mix.exs : def deps do [ { :spawn_sdk , &quot;~&gt; 0.5.0&quot; } , # You can uncomment one of those dependencies if you are going to use Persistent Actors \#{:spawn_statestores_mysql, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_postgres, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_mssql, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_cockroachdb, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_sqlite, &quot;~&gt; 0.5.0&quot;}, ] end Deploy Following steps below you will have a valid Elixir application to use in a Spawn cluster. However, you will still need to generate a container image with your application so that you can use it together with the Spawn Operator for Kubernetes . How to use After creating an elixir application project create the protobuf files for your business domain. It is common practice to do this under the priv/ folder. Let's demonstrate an example: syntax = &quot;proto3&quot;; package io.eigr.spawn.example; message MyState { int32 value = 1; } message MyBusinessMessage { int32 value = 1; } It is important to try to separate the type of message that must be stored as the actors' state from the type of messages that will be exchanged between their actors' operations calls. In other words, the Actor's internal state is also represented as a protobuf type, and it is a good practice to separate these types of messages from the others in its business domain. In the above case MyState is the type protobuf that represents the state of the Actor that we will create later while MyBusiness is the type of message that we will send and receive from this Actor. Now that we have defined our input and output types as Protobuf types we will need to compile these files to generate their respective Elixir modules. An example of how to do this can be found here NOTE: You need to have installed the elixir plugin for protoc. More information on how to obtain and install the necessary tools can be found here here Now that the protobuf types have been created we can proceed with the code. Example definition of an Actor: defmodule SpawnSdkExample.Actors.MyActor do use SpawnSdk.Actor , name : &quot;jose&quot; , persistent : true , state_type : Io.Eigr.Spawn.Example.MyState , deactivate_timeout : 30_000 , snapshot_timeout : 2_000 require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value % Value { } |&gt; Value . of ( % MyBusinessMessage { value : new_value } , % MyState { value : new_value } ) |&gt; Value . reply! ( ) end end In this example we are creating an actor in an Named/Eager way ie it is a known actor at compile time. We can also create Unnamed Dyncamic/Lazy actors, that is, despite having its abstract behavior defined at compile time, a Lazy actor will only have a concrete instance when it is associated with an identifier/name at runtime. Below follows the same previous actor being defined as abstract. defmodule SpawnSdkExample.Actors.AbstractActor do use SpawnSdk.Actor , abstract : true , persistent : true , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value % Value { } |&gt; Value . of ( % MyBusinessMessage { value : new_value } , % MyState { value : new_value } ) |&gt; Value . reply! ( ) end end Notice that the only thing that has changed is the absence of the name argument definition and the abstract argument definition being set to true. NOTE: Can Elixir programmers think in terms of named vs abstract actors as more or less known at startup vs dynamically supervised/registered? That is, defining your actors directly in the supervision tree or using a Dynamic Supervisor for that. Side Effects Actors can also emit side effects to other Actors as part of their response. See an example: defmodule SpawnSdkExample.Actors.AbstractActor do use SpawnSdk.Actor , abstract : true , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } alias SpawnSdk.Flow.SideEffect defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value result = % MyBusinessMessage { value : new_value } new_state = % MyState { value : new_value } Value . of ( ) |&gt; Value . value ( result ) |&gt; Value . state ( new_state ) |&gt; Value . effects ( # This returns a list of side effects. In this case containing only one effect. However, multiple effects can be chained together, # just by calling the effect function as shown here. # If only one effect is desired, you can also choose to use the to/3 function together with Value.effect(). # Example: Values.effect(SideEffect.to(name, func, payload)) SideEffect . of ( ) |&gt; SideEffect . effect ( &quot;joe&quot; , :sum , result ) ) |&gt; Value . reply! ( ) end end In the example above we see that the Actor joe will receive a request as a side effect from the Actor who issued this effect. Side effects do not interfere with an actor's request-response flow. They will &quot;always&quot; be processed asynchronously and any response sent back from the Actor receiving the effect will be ignored by the effector. Pipe and Forward Actors can also route some commands to other actors as part of their response. See an example: defmodule SpawnSdkExample.Actors.ForwardPipeActor do use SpawnSdk.Actor , name : &quot;pipeforward&quot; , abstract : false , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example.MyBusinessMessage defact forward_example ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : 999 ) ) |&gt; Value . forward ( Forward . to ( &quot;second_actor&quot; , &quot;sum_plus_one&quot; ) ) |&gt; Value . void ( ) end defact pipe_example ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : 999 ) ) |&gt; Value . pipe ( Pipe . to ( &quot;second_actor&quot; , &quot;sum_plus_one&quot; ) ) |&gt; Value . void ( ) end end defmodule SpawnSdkExample.Actors.SecondActorExample do use SpawnSdk.Actor , name : &quot;second_actor&quot; , abstract : false , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example.MyBusinessMessage defact sum_plus_one ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : msg . value + 1 ) ) |&gt; Value . void ( ) end end We are returning void in both examples so we dont care about what is being stored in the actor state. In the case above, every time you call the forward_example the second_actor's sum_plus_one function will receive the value forwarded originally in the invocation as its input. The end result will be: iex&gt; SpawnSdk . invoke ( &quot;pipeforward&quot; , system : &quot;spawn-system&quot; , command : &quot;forward_example&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 2 } } For the Pipe example, the the second_actor's sum_plus_one function will always receive %MyBusinessMessage{value: 999} due to getting the value from the previous specification in the pipe_example command, the end result will be: iex&gt; SpawnSdk . invoke ( &quot;pipeforward&quot; , system : &quot;spawn-system&quot; , command : &quot;pipe_example&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1000 } } Broadcast Actors can also send messages to a group of actors at once as an action callback. See the example below: defmodule Fleet.Actors.Driver do use SpawnSdk.Actor , abstract : true , # Set ´driver´ channel for all actors of the same type (Fleet.Actors.Driver) channel : &quot;drivers&quot; , state_type : Fleet.Domain.Driver alias Fleet.Domain . { Driver , OfferRequest , OfferResponse , Point } require Logger @brain_actor_channel &quot;fleet-controllers&quot; defact update_position ( % Point { } = position , % Context { state : % Driver { id : name } = driver } = ctx ) do Logger . info ( &quot;Driver [ \#{ name } ] Received Update Position Event. Position: [ \#{ inspect ( position ) } ]. Context: \#{ inspect ( ctx ) } &quot; ) driver_state = % Driver { driver | position : position } % Value { } |&gt; Value . of ( driver_state , driver_state ) |&gt; Value . broadcast ( Broadcast . to ( @brain_actor_channel , &quot;driver_position&quot; , driver_state ) ) |&gt; Value . reply! ( ) end end In the case above, every time an Actor &quot;driver&quot; executes the update_position action it will send a message to all the actors participating in the channel called &quot;fleet-controllers&quot;. Timers Actors can also declare Actions that act recursively as timers. See an example below: defmodule SpawnSdkExample.Actors.ClockActor do use SpawnSdk.Actor , name : &quot;clock_actor&quot; , state_type : Io.Eigr.Spawn.Example.MyState , deactivate_timeout : 86_400_000 require Logger alias Io.Eigr.Spawn.Example.MyState @set_timer 15_000 defact clock ( % Context { state : state } = ctx ) do Logger . info ( &quot;[clock] Clock Actor Received Request. Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : 0 , else : state . value + 1 new_state = MyState . new ( value : new_value ) Value . of ( ) |&gt; Value . state ( new_state ) |&gt; Value . noreply! ( ) end end NOTE: Timers Actions are ephemeral and only exist while the Actor is Enabled, ie running. Therefore Timers are not persistent and will not reactivate a timer's Actor after it is deactivated. Note that in the example above we set the value of deactivate timeout to an exceptionally high number, this is done to make the Actor remain active. In the example above the ´clock´ action will be called every 15 seconds. Declaring the supervision tree Once we define our actors we can now declare our supervision tree: defmodule SpawnSdkExample.Application do @moduledoc false use Application @impl true def start ( _type , _args ) do children = [ { SpawnSdk.System.Supervisor , system : &quot;spawn-system&quot; , actors : [ SpawnSdkExample.Actors.MyActor , SpawnSdkExample.Actors.AbstractActor ] } ] opts = [ strategy : :one_for_one , name : SpawnSdkExample.Supervisor ] Supervisor . start_link ( children , opts ) end end To run the application via iex we can use the following command: MIX_ENV = prod USER_FUNCTION_PORT = 8092 PROXY_DATABASE_TYPE = mysql SPAWN_STATESTORE_KEY = 3 Jnb0hZiHIzHTOih7t2cTEPEpY98Tu1wvQkPfq / XwqE = iex -- name spawn_a2 @ 127.0 . 0.1 - S mix NOTE: This example uses the MySQL database as persistent storage for its actors. And it is also expected that you have previously created a database called eigr-functions-db in the MySQL instance. The full example of this application can be found here . Client API Examples To invoke Actors, use: iex&gt; SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 12 } } You can invoke actor default functions like &quot;get&quot; to get its current state SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;get&quot; ) Spawning Actors: iex&gt; SpawnSdk . spawn_actor ( &quot;robert&quot; , system : &quot;spawn-system&quot; , actor : SpawnSdkExample.Actors.AbstractActor ) { :ok , %{ &quot;robert&quot; =&gt; SpawnSdkExample.Actors.AbstractActor } } Invoke Spawned Actors: iex&gt; SpawnSdk . invoke ( &quot;robert&quot; , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 16 } } Invoke Actors in a lazy way without having to spawn them before: iex&gt; SpawnSdk . invoke ( &quot;robert_lazy&quot; , ref : SpawnSdkExample.Actors.AbstractActor , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } }","ref":"SpawnSdk.html","title":"SpawnSdk","type":"module"},{"doc":"Invokes a function for a actor_name Opts system this is required ref attribute attribute will always lookup to see if the referenced actor is already started or not. payload attribute is optional. command has default values that you can use to get current actor state get, get_state, Get, getState, GetState Examples iex&gt; SpawnSdk . invoke ( &quot;actor_name&quot; , ref : SpawnSdkExample.Actors.AbstractActor , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , # &quot;sum&quot; or :sum payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 5 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 5 } } iex&gt; SpawnSdk . invoke ( &quot;actor_name&quot; , system : &quot;spawn-system&quot; , command : &quot;get&quot; ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 5 } }","ref":"SpawnSdk.html#invoke/2","title":"SpawnSdk.invoke/2","type":"function"},{"doc":"Spawns a abstract actor A abstract actor means that you can spawn dynamically the same actor for multiple different names. It is analog to DynamicSupervisor Opts system this is required actor which actor you will register first argument to Examples iex&gt; SpawnSdk . spawn_actor ( &quot;actor_name&quot; , system : &quot;spawn-system&quot; , actor : SpawnSdkExample.Actors.AbstractActor )","ref":"SpawnSdk.html#spawn_actor/2","title":"SpawnSdk.spawn_actor/2","type":"function"},{"doc":"Documentation for Actor . Actor look like this: defmodule MyActor do use SpawnSdk.Actor , name : &quot;joe&quot; , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState , deactivate_timeout : 5_000 , snapshot_timeout : 2_000 require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } defact sum ( % MyBusinessMessage { value : value } = data } , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request...&quot; ) new_value = ( state . value || 0 ) + value % Value { } |&gt; Value . of ( % MyBusinessMessage { value : new_value } , % MyState { value : new_value } ) |&gt; Value . reply! ( ) end","ref":"SpawnSdk.Actor.html","title":"SpawnSdk.Actor","type":"behaviour"},{"doc":"","ref":"SpawnSdk.Actor.html#c:handle_command/2","title":"SpawnSdk.Actor.handle_command/2","type":"callback"},{"doc":"","ref":"SpawnSdk.Actor.html#t:command/0","title":"SpawnSdk.Actor.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.Actor.html#t:context/0","title":"SpawnSdk.Actor.context/0","type":"type"},{"doc":"","ref":"SpawnSdk.Actor.html#t:data/0","title":"SpawnSdk.Actor.data/0","type":"type"},{"doc":"","ref":"SpawnSdk.Actor.html#t:error/0","title":"SpawnSdk.Actor.error/0","type":"type"},{"doc":"","ref":"SpawnSdk.Actor.html#t:value/0","title":"SpawnSdk.Actor.value/0","type":"type"},{"doc":"","ref":"SpawnSdk.Context.html","title":"SpawnSdk.Context","type":"module"},{"doc":"","ref":"SpawnSdk.Context.html#t:t/0","title":"SpawnSdk.Context.t/0","type":"type"},{"doc":"Define actions like a Elixir functions Internal :defact_exports metadata saved as [ {action_name, %{timer: 10_000}}, {action_name2, %{timer: nil}} ]","ref":"SpawnSdk.Defact.html","title":"SpawnSdk.Defact","type":"module"},{"doc":"","ref":"SpawnSdk.Defact.html#defact/2","title":"SpawnSdk.Defact.defact/2","type":"macro"},{"doc":"","ref":"SpawnSdk.Flow.html","title":"SpawnSdk.Flow","type":"module"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html","title":"SpawnSdk.Flow.Broadcast","type":"module"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#to/2","title":"SpawnSdk.Flow.Broadcast.to/2","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#to/3","title":"SpawnSdk.Flow.Broadcast.to/3","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#t:channel/0","title":"SpawnSdk.Flow.Broadcast.channel/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#t:command/0","title":"SpawnSdk.Flow.Broadcast.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#t:payload/0","title":"SpawnSdk.Flow.Broadcast.payload/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Broadcast.html#t:t/0","title":"SpawnSdk.Flow.Broadcast.t/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Forward.html","title":"SpawnSdk.Flow.Forward","type":"module"},{"doc":"","ref":"SpawnSdk.Flow.Forward.html#to/2","title":"SpawnSdk.Flow.Forward.to/2","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.Forward.html#t:actor_name/0","title":"SpawnSdk.Flow.Forward.actor_name/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Forward.html#t:command/0","title":"SpawnSdk.Flow.Forward.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Forward.html#t:t/0","title":"SpawnSdk.Flow.Forward.t/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Pipe.html","title":"SpawnSdk.Flow.Pipe","type":"module"},{"doc":"","ref":"SpawnSdk.Flow.Pipe.html#to/2","title":"SpawnSdk.Flow.Pipe.to/2","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.Pipe.html#t:actor_name/0","title":"SpawnSdk.Flow.Pipe.actor_name/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Pipe.html#t:command/0","title":"SpawnSdk.Flow.Pipe.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.Pipe.html#t:t/0","title":"SpawnSdk.Flow.Pipe.t/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html","title":"SpawnSdk.Flow.SideEffect","type":"module"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#effect/5","title":"SpawnSdk.Flow.SideEffect.effect/5","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#of/0","title":"SpawnSdk.Flow.SideEffect.of/0","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#to/4","title":"SpawnSdk.Flow.SideEffect.to/4","type":"function"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#t:actor_name/0","title":"SpawnSdk.Flow.SideEffect.actor_name/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#t:command/0","title":"SpawnSdk.Flow.SideEffect.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#t:payload/0","title":"SpawnSdk.Flow.SideEffect.payload/0","type":"type"},{"doc":"","ref":"SpawnSdk.Flow.SideEffect.html#t:t/0","title":"SpawnSdk.Flow.SideEffect.t/0","type":"type"},{"doc":"","ref":"SpawnSdk.Interface.html","title":"SpawnSdk.Interface","type":"module"},{"doc":"","ref":"SpawnSdk.System.html","title":"SpawnSdk.System","type":"behaviour"},{"doc":"","ref":"SpawnSdk.System.html#c:invoke/2","title":"SpawnSdk.System.invoke/2","type":"callback"},{"doc":"","ref":"SpawnSdk.System.html#c:register/2","title":"SpawnSdk.System.register/2","type":"callback"},{"doc":"","ref":"SpawnSdk.System.html#c:spawn_actor/2","title":"SpawnSdk.System.spawn_actor/2","type":"callback"},{"doc":"","ref":"SpawnSdk.System.html#t:actor_mod/0","title":"SpawnSdk.System.actor_mod/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:actor_name/0","title":"SpawnSdk.System.actor_name/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:actors/0","title":"SpawnSdk.System.actors/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:command/0","title":"SpawnSdk.System.command/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:invoke_opts/0","title":"SpawnSdk.System.invoke_opts/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:payload/0","title":"SpawnSdk.System.payload/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:spawn_actor_opts/0","title":"SpawnSdk.System.spawn_actor_opts/0","type":"type"},{"doc":"","ref":"SpawnSdk.System.html#t:system/0","title":"SpawnSdk.System.system/0","type":"type"},{"doc":"SpawnSystem","ref":"SpawnSdk.System.SpawnSystem.html","title":"SpawnSdk.System.SpawnSystem","type":"module"},{"doc":"","ref":"SpawnSdk.System.SpawnSystem.html#call/3","title":"SpawnSdk.System.SpawnSystem.call/3","type":"function"},{"doc":"hey","ref":"SpawnSdk.System.SpawnSystem.html#invoke/2","title":"SpawnSdk.System.SpawnSystem.invoke/2","type":"function"},{"doc":"","ref":"SpawnSdk.System.SpawnSystem.html#merge_cache_actors/2","title":"SpawnSdk.System.SpawnSystem.merge_cache_actors/2","type":"function"},{"doc":"Documentation for System.Supervisor . Start Supervisor tree like this: defmodule MyApp.Application do use Application @impl true def start ( _type , _args ) do children = [ { SpawnSdk.System.Supervisor , system : &quot;my-system&quot; , actors : [ MyActor ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end","ref":"SpawnSdk.System.Supervisor.html","title":"SpawnSdk.System.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SpawnSdk.System.Supervisor.html#child_spec/1","title":"SpawnSdk.System.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"SpawnSdk.System.Supervisor.html#start_link/1","title":"SpawnSdk.System.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html","title":"SpawnSdk.Value","type":"module"},{"doc":"","ref":"SpawnSdk.Value.html#broadcast/2","title":"SpawnSdk.Value.broadcast/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#effect/2","title":"SpawnSdk.Value.effect/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#effects/2","title":"SpawnSdk.Value.effects/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#forward/2","title":"SpawnSdk.Value.forward/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#noreply!/2","title":"SpawnSdk.Value.noreply!/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#noreply_state!/1","title":"SpawnSdk.Value.noreply_state!/1","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#of/0","title":"SpawnSdk.Value.of/0","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#of/3","title":"SpawnSdk.Value.of/3","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#pipe/2","title":"SpawnSdk.Value.pipe/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#reply!/1","title":"SpawnSdk.Value.reply!/1","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#state/2","title":"SpawnSdk.Value.state/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#value/2","title":"SpawnSdk.Value.value/2","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#void/1","title":"SpawnSdk.Value.void/1","type":"function"},{"doc":"","ref":"SpawnSdk.Value.html#t:broadcast/0","title":"SpawnSdk.Value.broadcast/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:effects/0","title":"SpawnSdk.Value.effects/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:forward/0","title":"SpawnSdk.Value.forward/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:new_state/0","title":"SpawnSdk.Value.new_state/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:pipe/0","title":"SpawnSdk.Value.pipe/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:response/0","title":"SpawnSdk.Value.response/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:t/0","title":"SpawnSdk.Value.t/0","type":"type"},{"doc":"","ref":"SpawnSdk.Value.html#t:value/0","title":"SpawnSdk.Value.value/0","type":"type"},{"doc":"Spawn Elixir SDK is the support library for the Spawn Actors System. Spawn is a Stateful Serverless Platform for provide the multi-language Actor Model. For a broader understanding of Spawn please consult its official repository . The advantage of the Elixir SDK over other SDKs is in Elixir's native ability to connect directly to an Erlang network. For this reason the Elixir SDK allows any valid Elixir application to be part of a Spawn network without the need for a sidecar attached.","ref":"readme.html","title":"Spawn Elixir SDK","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding spawn_sdk and spawn_statestores_* to your list of dependencies in mix.exs : def deps do [ { :spawn_sdk , &quot;~&gt; 0.5.0&quot; } , # You can uncomment one of those dependencies if you are going to use Persistent Actors \#{:spawn_statestores_mysql, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_postgres, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_mssql, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_cockroachdb, &quot;~&gt; 0.5.0&quot;}, \#{:spawn_statestores_sqlite, &quot;~&gt; 0.5.0&quot;}, ] end Deploy Following steps below you will have a valid Elixir application to use in a Spawn cluster. However, you will still need to generate a container image with your application so that you can use it together with the Spawn Operator for Kubernetes .","ref":"readme.html#installation","title":"Spawn Elixir SDK - Installation","type":"extras"},{"doc":"After creating an elixir application project create the protobuf files for your business domain. It is common practice to do this under the priv/ folder. Let's demonstrate an example: syntax = &quot;proto3&quot;; package io.eigr.spawn.example; message MyState { int32 value = 1; } message MyBusinessMessage { int32 value = 1; } It is important to try to separate the type of message that must be stored as the actors' state from the type of messages that will be exchanged between their actors' operations calls. In other words, the Actor's internal state is also represented as a protobuf type, and it is a good practice to separate these types of messages from the others in its business domain. In the above case MyState is the type protobuf that represents the state of the Actor that we will create later while MyBusiness is the type of message that we will send and receive from this Actor. Now that we have defined our input and output types as Protobuf types we will need to compile these files to generate their respective Elixir modules. An example of how to do this can be found here NOTE: You need to have installed the elixir plugin for protoc. More information on how to obtain and install the necessary tools can be found here here Now that the protobuf types have been created we can proceed with the code. Example definition of an Actor: defmodule SpawnSdkExample.Actors.MyActor do use SpawnSdk.Actor , name : &quot;jose&quot; , persistent : true , state_type : Io.Eigr.Spawn.Example.MyState , deactivate_timeout : 30_000 , snapshot_timeout : 2_000 require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value % Value { } |&gt; Value . of ( % MyBusinessMessage { value : new_value } , % MyState { value : new_value } ) |&gt; Value . reply! ( ) end end In this example we are creating an actor in an Named/Eager way ie it is a known actor at compile time. We can also create Unnamed Dyncamic/Lazy actors, that is, despite having its abstract behavior defined at compile time, a Lazy actor will only have a concrete instance when it is associated with an identifier/name at runtime. Below follows the same previous actor being defined as abstract. defmodule SpawnSdkExample.Actors.AbstractActor do use SpawnSdk.Actor , abstract : true , persistent : true , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value % Value { } |&gt; Value . of ( % MyBusinessMessage { value : new_value } , % MyState { value : new_value } ) |&gt; Value . reply! ( ) end end Notice that the only thing that has changed is the absence of the name argument definition and the abstract argument definition being set to true. NOTE: Can Elixir programmers think in terms of named vs abstract actors as more or less known at startup vs dynamically supervised/registered? That is, defining your actors directly in the supervision tree or using a Dynamic Supervisor for that.","ref":"readme.html#how-to-use","title":"Spawn Elixir SDK - How to use","type":"extras"},{"doc":"Actors can also emit side effects to other Actors as part of their response. See an example: defmodule SpawnSdkExample.Actors.AbstractActor do use SpawnSdk.Actor , abstract : true , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example . { MyState , MyBusinessMessage } alias SpawnSdk.Flow.SideEffect defact sum ( % MyBusinessMessage { value : value } = data , % Context { state : state } = ctx ) do Logger . info ( &quot;Received Request: \#{ inspect ( data ) } . Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : value , else : ( state . value || 0 ) + value result = % MyBusinessMessage { value : new_value } new_state = % MyState { value : new_value } Value . of ( ) |&gt; Value . value ( result ) |&gt; Value . state ( new_state ) |&gt; Value . effects ( # This returns a list of side effects. In this case containing only one effect. However, multiple effects can be chained together, # just by calling the effect function as shown here. # The delay means that it will be fired asynchronously after 5000 milliseconds (5 seconds) # If only one effect is desired, you can also choose to use the to/3 function together with Value.effect(). # Example: Values.effect(SideEffect.to(name, func, payload)) SideEffect . of ( ) |&gt; SideEffect . effect ( &quot;joe&quot; , :sum , result , delay : 5_000 , scheduled_to : ~U[2020-01-01 10:00:00.145Z] ) # use delay or scheduled_to, not both ) |&gt; Value . reply! ( ) end end In the example above we see that the Actor joe will receive a request as a side effect from the Actor who issued this effect. Side effects do not interfere with an actor's request-response flow. They will &quot;always&quot; be processed asynchronously and any response sent back from the Actor receiving the effect will be ignored by the effector.","ref":"readme.html#side-effects","title":"Spawn Elixir SDK - Side Effects","type":"extras"},{"doc":"Actors can also route some commands to other actors as part of their response. See an example: defmodule SpawnSdkExample.Actors.ForwardPipeActor do use SpawnSdk.Actor , name : &quot;pipeforward&quot; , abstract : false , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example.MyBusinessMessage defact forward_example ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : 999 ) ) |&gt; Value . forward ( Forward . to ( &quot;second_actor&quot; , &quot;sum_plus_one&quot; ) ) |&gt; Value . void ( ) end defact pipe_example ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : 999 ) ) |&gt; Value . pipe ( Pipe . to ( &quot;second_actor&quot; , &quot;sum_plus_one&quot; ) ) |&gt; Value . void ( ) end end defmodule SpawnSdkExample.Actors.SecondActorExample do use SpawnSdk.Actor , name : &quot;second_actor&quot; , abstract : false , persistent : false , state_type : Io.Eigr.Spawn.Example.MyState require Logger alias Io.Eigr.Spawn.Example.MyBusinessMessage defact sum_plus_one ( % MyBusinessMessage { } = msg , _ctx ) do Logger . info ( &quot;Received request with \#{ msg . value } &quot; ) Value . of ( ) |&gt; Value . value ( MyBusinessMessage . new ( value : msg . value + 1 ) ) |&gt; Value . void ( ) end end We are returning void in both examples so we dont care about what is being stored in the actor state. In the case above, every time you call the forward_example the second_actor's sum_plus_one function will receive the value forwarded originally in the invocation as its input. The end result will be: iex&gt; SpawnSdk . invoke ( &quot;pipeforward&quot; , system : &quot;spawn-system&quot; , command : &quot;forward_example&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 2 } } For the Pipe example, the the second_actor's sum_plus_one function will always receive %MyBusinessMessage{value: 999} due to getting the value from the previous specification in the pipe_example command, the end result will be: iex&gt; SpawnSdk . invoke ( &quot;pipeforward&quot; , system : &quot;spawn-system&quot; , command : &quot;pipe_example&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1000 } }","ref":"readme.html#pipe-and-forward","title":"Spawn Elixir SDK - Pipe and Forward","type":"extras"},{"doc":"Actors can also send messages to a group of actors at once as an action callback. See the example below: defmodule Fleet.Actors.Driver do use SpawnSdk.Actor , abstract : true , # Set ´driver´ channel for all actors of the same type (Fleet.Actors.Driver) channel : &quot;drivers&quot; , state_type : Fleet.Domain.Driver alias Fleet.Domain . { Driver , OfferRequest , OfferResponse , Point } require Logger @brain_actor_channel &quot;fleet-controllers&quot; defact update_position ( % Point { } = position , % Context { state : % Driver { id : name } = driver } = ctx ) do Logger . info ( &quot;Driver [ \#{ name } ] Received Update Position Event. Position: [ \#{ inspect ( position ) } ]. Context: \#{ inspect ( ctx ) } &quot; ) driver_state = % Driver { driver | position : position } % Value { } |&gt; Value . of ( driver_state , driver_state ) |&gt; Value . broadcast ( Broadcast . to ( @brain_actor_channel , &quot;driver_position&quot; , driver_state ) ) |&gt; Value . reply! ( ) end end In the case above, every time an Actor &quot;driver&quot; executes the update_position action it will send a message to all the actors participating in the channel called &quot;fleet-controllers&quot;.","ref":"readme.html#broadcast","title":"Spawn Elixir SDK - Broadcast","type":"extras"},{"doc":"Actors can also declare Actions that act recursively as timers. See an example below: defmodule SpawnSdkExample.Actors.ClockActor do use SpawnSdk.Actor , name : &quot;clock_actor&quot; , state_type : Io.Eigr.Spawn.Example.MyState , deactivate_timeout : 86_400_000 require Logger alias Io.Eigr.Spawn.Example.MyState @set_timer 15_000 defact clock ( % Context { state : state } = ctx ) do Logger . info ( &quot;[clock] Clock Actor Received Request. Context: \#{ inspect ( ctx ) } &quot; ) new_value = if is_nil ( state ) , do : 0 , else : state . value + 1 new_state = MyState . new ( value : new_value ) Value . of ( ) |&gt; Value . state ( new_state ) |&gt; Value . noreply! ( ) end end NOTE: Timers Actions are ephemeral and only exist while the Actor is Enabled, ie running. Therefore Timers are not persistent and will not reactivate a timer's Actor after it is deactivated. Note that in the example above we set the value of deactivate timeout to an exceptionally high number, this is done to make the Actor remain active. In the example above the ´clock´ action will be called every 15 seconds. Declaring the supervision tree Once we define our actors we can now declare our supervision tree: defmodule SpawnSdkExample.Application do @moduledoc false use Application @impl true def start ( _type , _args ) do children = [ { SpawnSdk.System.Supervisor , system : &quot;spawn-system&quot; , actors : [ SpawnSdkExample.Actors.MyActor , SpawnSdkExample.Actors.AbstractActor ] } ] opts = [ strategy : :one_for_one , name : SpawnSdkExample.Supervisor ] Supervisor . start_link ( children , opts ) end end To run the application via iex we can use the following command: MIX_ENV = prod USER_FUNCTION_PORT = 8092 PROXY_DATABASE_TYPE = mysql SPAWN_STATESTORE_KEY = 3 Jnb0hZiHIzHTOih7t2cTEPEpY98Tu1wvQkPfq / XwqE = iex -- name spawn_a2 @ 127.0 . 0.1 - S mix NOTE: This example uses the MySQL database as persistent storage for its actors. And it is also expected that you have previously created a database called eigr-functions-db in the MySQL instance. The full example of this application can be found here .","ref":"readme.html#timers","title":"Spawn Elixir SDK - Timers","type":"extras"},{"doc":"To invoke Actors, use: iex&gt; SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 12 } } You can invoke actor default functions like &quot;get&quot; to get its current state SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;get&quot; ) Spawning Actors: iex&gt; SpawnSdk . spawn_actor ( &quot;robert&quot; , system : &quot;spawn-system&quot; , actor : SpawnSdkExample.Actors.AbstractActor ) { :ok , %{ &quot;robert&quot; =&gt; SpawnSdkExample.Actors.AbstractActor } } Invoke Spawned Actors: iex&gt; SpawnSdk . invoke ( &quot;robert&quot; , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 16 } } Invoke Actors in a lazy way without having to spawn them before: iex&gt; SpawnSdk . invoke ( &quot;robert_lazy&quot; , ref : SpawnSdkExample.Actors.AbstractActor , system : &quot;spawn-system&quot; , command : &quot;sum&quot; , payload : % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } ) { :ok , % Io.Eigr.Spawn.Example.MyBusinessMessage { value : 1 } } Invoke Actors with a delay set in milliseconds: iex&gt; SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;ping&quot; , delay : 5_000 ) { :ok , :async } Invoke Actors scheduled to a specific DateTime: iex&gt; SpawnSdk . invoke ( &quot;joe&quot; , system : &quot;spawn-system&quot; , command : &quot;ping&quot; , scheduled_to : ~U[2023-01-01 00:32:00.145Z] ) { :ok , :async }","ref":"readme.html#client-api-examples","title":"Spawn Elixir SDK - Client API Examples","type":"extras"}]